package edu.cmu.paid.network.test;

import java.lang.String;
import edu.cmu.paid.network.CNetwork_Api;
import edu.cmu.paid.network.voyager.*;

/** This test is to exercise the multicasting via the network API.
  * CAUTION: For this code to work, you must start Voyager (by running
  * java edu.cmu.paid.network.test.VoyagerStartup //host:port) on 
  * remote machines specified below by ma3 and ma4.
  * @author Barrett Trask
  */

public class MulticastTest{
  
  public static void main(String argv[]){
    CNetwork_Api nAPI;
    MulticastAgent ma1, ma2;
    IMulticastAgent ma3, ma4;
    MulticastTestObject o1, o2, o3, o4;

    try{

      System.out.println("1");

      nAPI = new CNetwork_Api();
      nAPI.clientStartup();

      System.out.println("2");


      o1 = new MulticastTestObject();
      o1.name = "o1";
      o2 = new MulticastTestObject();
      o2.name = "o2";
      o3 = new MulticastTestObject();
      o3.name = "o3";
      o4 = new MulticastTestObject();
      o4.name = "o4";

      //nAPI.serverStartup("//viennese.se.cs.cmu.edu:7000");
      System.out.println("3");

 
      ma1 = nAPI.getNewMulticastAgent();
      ma2 = nAPI.getNewMulticastAgent();

      System.out.println("4");

      ma3 = nAPI.getNewRemoteMulticastAgent("//java.se.cs.cmu.edu:8000/ma3");
      System.out.println("5");
      ma4 = nAPI.getNewRemoteMulticastAgent("//java.se.cs.cmu.edu:9000/ma4");

      System.out.println("6");


      nAPI.connectAgents(ma1, ma2);
      nAPI.connectAgents(ma2, ma3);
      nAPI.connectAgents(ma3, ma4);
      System.out.println("connected");

      nAPI.addObjectToAgent(ma1, o1);
      nAPI.addObjectToAgent(ma2, o2);
      nAPI.addObjectToAgent(ma3, o3);
      nAPI.addObjectToAgent(ma4, o4);
      System.out.println("Objects added");

      nAPI.multicastMessage(ma1, "receiveMessage", new Object[]{"message1"}, 
                            "edu.cmu.paid.network.test.MulticastTestObject");
 
     nAPI.disconnectMachine();

    } catch (java.lang.Exception e){
      System.err.println(e);
    }
  }

}
